#include<iostream>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q;
    cin >> n >> q;
    long long zbir1=0;
    long long zbir2=0;
    long long d[n];
    long long p[n];
    long long k[q];
    for(int i=0; i<n; i++){
        cin >> d[i] >> p[i];
        zbir2+=p[i];

    }
    for(int j=0; j<q; j++){
        cin >> k[j];
    }
    long long brojac[q];
	for(int j=0; j<q; j++){
        brojac[j] = 0;
    }
    for(int i=0; i<n; i++){
        for(int j = 0; j<q; j++){
            if(d[i]<=k[j]){
                if(p[i]<abs(k[j] - d[i])){
                    brojac[j]+=p[i];
                }
                else{
				if(p[i]>=d[i]){
                    	brojac[j]+=abs(k[j]-d[i]);
						brojac[j]++;
					}
				else{
				    brojac[j]+=abs(k[j]-p[i]);
					brojac[j]++;

}				

                }
            }
            if(k[j]>=zbir2){
                brojac[j]=zbir2;
            }
        }
    }
    for(int j=0; j<q; j++){
        cout << brojac[j] <<'\n';
    }



    return 0;
}